;-------------------------------------------
; MP3 Player V1.0 - MANAGER PLUGIN
; Tomas Pribyl, Josef Soucek 2000, 2001
; 
; dundera@volny.cz
; www.volny.cz/dundera
;
; 04/08/2000 First release
; 06/08/2000 Streaming system changed
; 02/03/2001 Download microcode to STA013
;-------------------------------------------



DevAddr        = $86     ;STA013 device address

buf1begin      = $2000   ;Buffer1 
buf1end        = $5f80
buf2begin      = $6000   ;Buffer2 
buf2end        = $9f80

LoadAddyPtr    = $fb     ;($fb,$fc) ukazatel:  load-adresa
status         = $90     ;($90) byte:  I/O status


ShowNum        = $0427   ;Number of current playing buffer on screen

SCPU_normal    = $d07a
SCPU_turbo     = $d07b

mp3_status     = $de41
mp3_data       = $de40   ;Read  = Version $00
                         ;Write = MP3 Bitstream Data


                       
;---------------------------------------------------------------------

                .include "kernal.asm"


                * =  $1000
                jmp start_without_name ;tady to startuji rucne
                jmp start_with_name    ;tady je start MANAGERem
                
start_without_name = *
                lda #$80
              ;  sta man_sign    ;started from basic
                
                jsr clrchn
                jsr clall
                lda #<ProductTxt
                ldy #>ProductTxt
                jsr $ab1e

                lda #<FileTxt  ;input filename
                ldy #>FileTxt
                jsr $ab1e

                ldy #$00
getfilename     jsr chrin
                cmp #$0d
                beq geted
                sta mp3_name,y
                iny
                jmp getfilename
                
geted           tya
                ldx #<mp3_name
                ldy #>mp3_name
                jsr SetNam
                jmp SkipName

;-----------------------------------------------------------------------
; STARTED from MANAGER                
start_with_name pha
                tya
                pha
                txa
                pha
                
                lda #$00
             ;   sta man_sign
                lda #$93     ;clrscreen
                jsr chrout
                lda #<ProductTxt
                ldy #>ProductTxt
                jsr $ab1e
                
                pla
                tax
                pla
                tay
                pla

               jsr setnam
               

;--------------
SkipName       lda #1             ;File Number
               ldx $ba            ;Actual device Number
               ldy #0             ;Type: Reading
               jsr setlfs
               jsr open           ;Otevreni souboru
               bcc open_ok
               
ExitLoading    lda #1             ;File Open Error  
               jsr close          ;Close File
               jsr clall          ;Close All Files
               rts
               
open_ok        = *                ;OK status pri otevreni souboru
               ldx #1
               jsr chkin          ;Nastav soubor jako vstupni
               bcs ExitLoading
;--------------------------------------
;               lda #%00001011     ;VYPNOUT obrazovku
;               sta 53248+17


               jsr initI2C         ;Init I2C BUS
               lda #$72            ;RUN (reset=$00)
               sta RegAddr
               jsr ReadI2C
               cmp #$00
               bne NowPatched 
               
               jsr PatchSTA013     ;STA013 wasn't patched, patch it now
               
NowPatched     jsr ResetChip       ;
               jsr InitChip
               
               lda #<PlayTxt
               ldy #>PlayTxt
               jsr $ab1e

               ldy #$00
PrintName      lda ($bb),y
               jsr Chrout
               iny
               cpy $b7
               bne PrintName
               
               sei                ;Zatim bez IRQ
;               lda 53248+17
;               sta VicConfig
;               lda #$00
;               sta 53248+17
               
               lda #$00
               sta EndFileInBuf1   ;initialize flags
               sta EndFileInBuf2
               lda #$ff
               sta PlayFinished
               
               lda #<Buf1End
               sta Play1EndLo+1
               lda #>Buf1End
               sta Play1EndHi+1
               
               lda #<Buf2End
               sta Play2EndLo+1
               lda #>Buf2End 
               sta Play2EndHi+1
                       

               lda #<buf1begin
               sta play1_addr+1
               lda #>buf1begin
               sta play1_addr+2

               jsr LoadBuf1       ;Nahraje buffer1 z HDD
               lda status
               bne LoadMp3Err
               
               jsr LoadBuf2       ;Nahraje buffer2 z HDD
               lda status
               beq Buff2LoadOk
               
LoadMp3Err     jmp Exit_Player
               
Buff2LoadOk    lda #1
               sta active_BufNumb
               
               lda $0318          ;save old NMI vector
               sta OldNmiVect
               lda $0319
               sta OldNmiVect+1
               
               lda #<play1        ;Prehravani z BUFFERU 1 (NMI cast 1)
               sta $0318
               lda #>play1
               sta $0319
               
               lda #$80           ;Zapne NMI enable v MP3 karte
               sta mp3_status
               
;--------------------------------------
play_loop      = *
               lda #"2"
               sta ShowNum
wait_2_buff2   = *
               lda $dc01
               cmp #%01111111     ;RUN/STOP pressed
               beq exit_player
              
               lda active_BufNumb ;Ceka az bude buffer1
               cmp #1             ;neaktivni
               beq wait_2_buff2
               
               lda #" "
               sta ShowNum
               
               jsr LoadBuf1       ;Nahraje do bufferu1 z HDD
               lda status
               sta EndFileInBuf1  ;uschovat status prislusneho bufferu
               beq Buff1Full      ;soubor jeste neskoncil
               
               stx Play1EndLo+1   ;nastavit konec bufferu1 pro prehravani LOW
               tya
               clc
               adc #<Buf1Begin
               sta Play1EndHi+1   ;nastavit konec bufferu1 pro prehravani HI
               jmp EndPlay
               
               
Buff1Full      lda #"1"
               sta ShowNum

wait_2_buff1   = *
               lda $dc01
               cmp #%01111111     ;RUN/STOP pressed
               beq exit_player
              
               lda active_BufNumb ;Ceka az bude buffer2
               cmp #2             ;neaktivni
               beq wait_2_buff1
               
               lda #" "
               sta ShowNum

               jsr LoadBuf2       ;Nahraje do bufferu2 z HDD
               lda status
               sta EndFileInBuf2
               beq Play_Loop
               
               stx Play2EndLo+1
               tya
               clc
               adc #<Buf2Begin
               sta Play2EndHi+1 
               

EndPlay        lda PlayFinished   ;wait until playing not finished
               bne EndPlay
               
;--------------------------------------
exit_player    = *
               lda #$00           ;MP3 card NMI disable
               sta mp3_status

               lda #1
               jsr close
               jsr clall
               lda OldNmiVect
               sta $0318
               lda OldNmiVect+1
               sta $0319
;               lda VicConfig
;               sta 53248+17
               cli
               rts                ;end of program

;--------------------------------------
LoadBuf1       = *
               ldx #<buf1begin    ;Start-addy (e.g. $1000)
               ldy #>buf1begin
               stx LoadAddyPtr
               sty LoadAddyPtr+1
               lda #LoadAddyPtr         ;Start-addy pointer (zero-page pointer)
               ldx #<buf1end-buf1begin  ;Read block length
               ldy #>buf1end-buf1begin
               jmp hddread
;--------------------------------------
LoadBuf2       = *
               ldx #<buf2begin    ;Start-addy (e.g. $3000)
               ldy #>buf2begin
               stx LoadAddyPtr
               sty LoadAddyPtr+1
               lda #LoadAddyPtr         ;Start-addy pointer (zero-page pointer)
               ldx #<buf2end-buf2begin  ;Read block length
               ldy #>buf2end-buf2begin
               jmp hddread

;--------------------------------------
; Prehravani z BUFFERU 1
;--------------------------------------
play1          = *
               pha
               
play1_loop     = *
               bit mp3_status
               bvc play_mp3_exit

               lda play1_addr+2
Play1EndHi     cmp #>buf1end
               bne play1_addr
               lda play1_addr+1
Play1EndLo     cmp #<buf1end
               beq play1_end

play1_addr     lda $1000
               sta mp3_data

               inc play1_addr+1
               bne play1_loop
               inc play1_addr+2
               bne play1_loop
               ;---
                                  ;Cely BUFFER 1 uz se prehral

play1_end      lda #2             ;Buffer 2 oznaci jako aktivni
               sta active_BufNumb
               
               lda EndFileInBuf1
               beq ContPlay2      ;soubor neskoncil, pokracovat dalsim bufferem
               
EndNmiPlay     lda #$00
               sta Mp3_Status     ;vypnout NMI
               sta PlayFinished
               jmp Play_Mp3_Exit  ;ukoncit NMI
               
               
ContPlay2      lda #<buf2begin    ;BUFFER 2 pointer
               sta play2_addr+1
               lda #>buf2begin
               sta play2_addr+2
               lda #<play2        ;Prehravani z BUFFERU 1
               sta $0318
               lda #>play2
               sta $0319
               jmp play2_loop
               
play_mp3_exit = *
               pla
               rti

;--------------------------------------
; Prehravani z BUFFERU 2
;--------------------------------------
play2          = *
               pha
               
play2_loop     = *
               bit mp3_status
               bvc play_mp3_exit
               
               lda play2_addr+2
Play2EndHi     cmp #>buf2end
               bne play2_addr
               lda play2_addr+1
Play2EndLo     cmp #<buf2end
               beq play2_end

play2_addr     lda $1000
               sta mp3_data

               inc play2_addr+1
               bne play2_loop
               inc play2_addr+2
               bne play2_loop
               ;---

play2_end      lda #1             ;Buffer 1 oznaci jako aktivni
               sta active_BufNumb
               
               lda EndFileInBuf2  ;File Ended In buffer2?
               bne EndNmiPlay     ;Yes, end of playing

ContPlay1      lda #<buf1begin    ;pointer to BUFFER 1
               sta play1_addr+1
               lda #>buf1begin
               sta play1_addr+2
               lda #<play1        ;Prehravani z BUFFERU 1
               sta $0318
               lda #>play1
               sta $0319
               jmp play1_loop
               


                    



;-----------------------------------------------------------------------------
;                     I2C communication routines
;
;-----------------------------------------------------------------------------
; ovladani jednotlivych vystupu

SetSDA          pha
                lda OutData
                ora #%00000010
                sta OutData
                sta MP3_Status
                pla
                rts


ClrSDA          pha
                lda OutData
                and #%11111101
                sta OutData
                sta MP3_Status
                pla
                rts

SetSCL          pha
                lda OutData
                ora #%00000001
                sta OutData
                sta MP3_Status
                pla
                rts
                

ClrSCL          pha
                lda OutData
                and #%11111110
                sta OutData
                sta MP3_Status
                pla
                rts

;----------------------------------------------------
; inicializace sbernice I2C
InitI2C         lda #$00
                sta OutData
                jsr SetSDA
                jsr SetSCL
                rts
                            
                            

;----------------------------------------------------
; Vytvoreni start bitu na sbernici I2C

MakeStartBit    jsr SetSCL        ; hodiny do 1
                jsr ClrSDA        ; data do 0
                jsr ClrSCL        ; hodiny do 0
                rts
                

;----------------------------------------------------
; vytvoreni StopBitu na sbernici I2C

MakeStopBit     jsr SetSCL        ; hodiny do 1
                jsr SetSDA        ; data do 1
                rts





;-----------------------------------------------------
; odesle na bajt I2C sbernici

SendByte        ldx #$08          ; pocet bitu k odeslani
SendI2CBit      asl a             ; shift dat k odeslani
                bcc SendBit0
                
                jsr SetSDA        ; nastavit data do 1
                jmp SendBit1
                
SendBit0        jsr ClrSDA        ; nastavit data do 0
SendBit1        jsr SetSCL        ; vzestupna hrana na hodinach
                jsr ClrSCL        ; sestupna hrana na hodinach
                dex
                bne SendI2CBit
                
                jsr SetSDA        ; uvolnit datovou sbernici
                jsr SetSCL        ; vzestupna hrana na hodinach
                
                lda MP3_Status    ; nacte data
                jsr ClrSCL
                
                lsr a
                lsr a             ; SDA do CY
                rts




;------------------------------------------------------
; precte data z I2C sbernice

ReadByte        ldx #$08          ; pocet bitu k prijmuti
                lda #$00
                sta InData
                
ReadBit         jsr SetSCL
                lda MP3_Status
                lsr a
                lsr a             ; SDA do CY
                rol InData        ; CY do vstupnich dat
                jsr ClrSCL
                dex
                bne ReadBit
                lda InData
                rts
                
                




;-------------------------------------------------------
; cte data z registru STA013 na I2C sbernici                


ReadI2C         jsr MakeStartBit  ; vytvoreni startbitu

                lda #DevAddr      ; cislo STA013 na I2C sbernici
                and #%11111110    ; priznak WRITE
                jsr SendByte
                bcc DevAddr_OK
                rts
                

DevAddr_OK      lda RegAddr       ; cislo registru urceneho ke cteni
                jsr SendByte
                bcc RegAddr_OK
                rts
                
RegAddr_OK      jsr MakeStartBit  ; vytvoreni StartBitu
                lda #DevAddr      ; cislo STA013 na I2C sbernici
                ora #%00000001    ; priznak READ
                jsr SendByte
                bcc DevAddr2_OK
                rts
                

DevAddr2_OK     jsr ReadByte      ; cteni bajtu
                jsr MakeStopBit   ; ukonceni prenosu StopBitem
                rts







;-----------------------------------------------------------
;  zapise data do registru STA013 na I2C sbernici

WriteI2C        sta SendData
                jsr MakeStartBit
                
                lda #DevAddr
                and #%11111110
                jsr SendByte
                bcc DevAddr3_OK
                rts
                
DevAddr3_OK     lda RegAddr
                jsr SendByte
                bcc RegAddr1_OK
                rts
                
RegAddr1_OK     lda SendData
                jsr SendByte
                bcc SendData_OK
                rts
                
SendData_OK     jsr MakeStopBit
                rts

                
SendData        .byte 0


;-----------------------------------------------------
; zapise RESET command do STA013


ResetChip       lda #$10           ; cislo reset registru
                sta RegAddr
                lda #$01           ; data
                jmp WriteI2C       ; zapsat do I2C registru



;-----------------------------------------------------
;
                
InitChip        ldy #0
                
InitNextReg     lda AddressTable,y ; cislo registru pro zapis
                cmp #$ff
                bne ContInit
                rts
                
ContInit        sta RegAddr
                lda ValueTable,y   ; hodnota k ulozeni do registru
                iny
                jsr WriteI2C       ; zapsat hodnotu do I2C registru
                jmp InitNextReg

AddressTable    .byte $54,$55,$52,$51,$50,$65,$64,$61,$06,$07,$0b,$05,$0d,$18,$0c,$72,$7d,$ff
ValueTable      .byte $03,$31,184,$00,$06,$00,$00,$05,$09,$00,$02,161,$04,$04,$05,$01,$00,$ff


;------------------------------------------------------
PatchSTA013     lda #<PatchTxt
                ldy #>PatchTxt
                jsr $ab1e

                lda #<Sta013_Data
                sta LoadAddyPtr
                lda #>STA013_Data
                sta LoadAddyPtr+1     ;init Patch data pointer
                
LoopPatch       ldy #$00
                lda (LoadAddyPtr),y   ;read Register Address
                cmp #$ff              ;end of patching mark
                beq EndOfPatching
                sta RegAddr
                inc LoadAddyPtr
                bne RdPatchData
                inc LoadAddyPtr+1
                
RdPatchData     lda (LoadAddyPtr),y
                inc LoadAddyPtr
                bne WriteReg
                inc LoadAddyPtr+1
                
WriteReg        jsr WriteI2C
                jmp LoopPatch

EndOfPatching   lda #<DoneTxt
                ldy #>DoneTxt
                jmp $ab1e
;------------------------------------------------------                
OldNmiVect      .byte $00,$00
VicConfig       .byte $00
OutData         .byte 0
InData          .byte 0
pInit           .byte 0
RegAddr         .byte 0

active_BufNumb  .byte 0            ;HODNOTA: 1 (aktivni je buffer1),
                                   ;         2 (aktivni je buffer2)
                                   ;(cislo bufferu prave zpracovavaneho NMIckem)

EndFileInBuf1   .byte 0            ;0-whole buffer loaded 
EndFileInBuf2   .byte 0            ;0-whole buffer loaded
PlayFinished    .byte 0            ;0-Playing finished


ProductTxt      .text $0d,$0d,"        IDE64 - MP3 PLAYER V1.0",$0d
                .text "         (C) TOMAS PRIBYL 2001",$0d,$0d,0
              
FileTxt        .text "MP3 FILENAME: ",0               
PlayTxt        .text $0d,"NOW PLAYING:",0
PatchTxt       .text $0d,"DOWNLOADING CODE TO MP3 PLAYER",$0d
               .text "PLEASE WAIT...",$0d,0
DoneTxt        .text "DONE.",$0d,$0d,0
;---------------------------------------------------------------------

               .include "sta013.asm"     ;config file for STA013

;---------------------------------------------------------------------
mp3_name       .text "1234567890123456"
;---------------------------------------------------------------------
               
